#ifndef CORE_INC_LCD_H_
#define CORE_INC_LCD_H_

#include <stdint.h>

#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"

#define CLEAR_DISPLAY_INSTRUCTION 		0x01

#define RETURN_HOME_INSTRUCTION 		0x02

#define ENTRY_MODE_INSTRUCTION			0x04
#define ENTRY_MODE_INC_CURSOR			0x02

#define DISPLAY_INSTRUCTION				0x08
#define DISPLAY_ON						0x04
#define DISPLAY_CURSOR_ON				0x02
#define DISPLAY_BLINK_ON				0x01

#define SHIFT_INSTRUCTION				0x10
#define SHIFT_DISPLAY					0x08
#define SHIFT_RIGHT						0x04

#define FUNCTION_INSTRUCTION			0x20
#define FUNCTION_2_LINES				0x08
#define FUNCTION_5x10_DOTS				0x04

#define SET_CGRAM_ADDRESS_INSTRUCTION	0x40

#define SET_DDRAM_ADDRESS_INSTRUCTION	0x80

typedef enum {
	LCD_INSTRUCTION, LCD_DATA
} LCD_Register;

typedef struct {
	LCD_Register reg;
	uint8_t data;
} LCD_Command;

void LCD_Init();
void LCD_Enqueue(LCD_Register reg, uint8_t data);

#endif
