#include "uart.h"
#include "usart.h"

QueueHandle_t UART_QueueHandle;
TaskHandle_t UART_TaskHandle;

void UART_Task(void *parameters) {
	UNUSED(parameters);
	uint8_t byte;
	while (1) {
		xQueueReceive(UART_QueueHandle, &byte, portMAX_DELAY);
		HAL_UART_Transmit_IT(&huart1, &byte, sizeof(uint8_t));
		ulTaskNotifyTake(pdTRUE, portMAX_DELAY);
	}
}

void HAL_UART_TxCpltCallback(UART_HandleTypeDef *huart) {
	if (huart->Instance != huart1.Instance) {
		return;
	}
	BaseType_t wokenTask = pdFALSE;
	vTaskNotifyGiveFromISR(UART_TaskHandle, &wokenTask);
	portYIELD_FROM_ISR(wokenTask);
}

void UART_Transmit(uint8_t byte) {
	xQueueSendToBack(UART_QueueHandle, &byte, portMAX_DELAY);
}

void UART_Init() {
	xTaskCreate(UART_Task, "UART_Task", 128, NULL, 5, &UART_TaskHandle);
	UART_QueueHandle = xQueueCreate(64, sizeof(uint8_t));
}
